package com.jisco.dynamicweight.dynamicbasescstation.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasereciever.model.DynamicBaseReciever;
import com.jisco.dynamicweight.dynamicbasescstation.model.DynamicBaseScStation;
import com.jisco.dynamicweight.dynamicbasescstation.service.IDynamicBaseScStationService;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * DynamicBaseScStation RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-01-05 11:28
 * 类描述
 * 修订历史：
 * 日期：2022-01-05
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseScStation RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasescstations")
public class DynamicBaseScStationController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseScStationService dynamicBaseScStationService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasescstation:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseScStation> list = dynamicBaseScStationService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasescstation:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<DynamicBaseScStation> list = dynamicBaseScStationService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据DynamicBaseScStation对象创建")
    @ApiImplicitParam(name = "dynamicBaseScStation", value = "详细实体dynamicBaseScStation", required = true, dataType = "DynamicBaseScStation")
    //@RequiresPermissions("dynamicbasescstation:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseScStation model){
        Assert.isTrue(StringUtils.isNotBlank(model.getName()), "请输入皮带秤名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getStationNum()), "请输入数采系统站点编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialName()), "请输入物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getSenderCode()), "请输入发货库房编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderName()), "请输入发货库房!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getSenderType()), "请输入发货点类型!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverCode()), "请输入收货库房编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverName()), "请输入收货库房!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverType()), "请输入收货点类型!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
//        Assert.notNull(model.getIsUpload(), "是否上传皮卡不能为空!");
//        Assert.notNull(model.getIsInbatches(), "是否分批不能为空!");
        model.setValidFlag("1");
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseScStation dynamicBaseScStation = dynamicBaseScStationService.add(model);
        return success(dynamicBaseScStation);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasescstation:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        DynamicBaseScStation dynamicBaseScStation = dynamicBaseScStationService.getById(id);
        return success(dynamicBaseScStation);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的dynamicBaseScStation信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "dynamicBaseScStation", value = "详细实体dynamicBaseScStation", required = true, dataType = "DynamicBaseScStation")
    })
    //@RequiresPermissions("dynamicbasescstation:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseScStation model){
        Assert.isTrue(StringUtils.isNotBlank(model.getName()), "请输入皮带秤名称!");
        Assert.isTrue(StringUtils.isNotBlank(model.getStationNum()), "请输入数采系统站点编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getMaterialName()), "请输入物料名称!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getSenderCode()), "请输入发货库房编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getSenderName()), "请输入发货库房!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getSenderType()), "请输入发货点类型!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverCode()), "请输入收货库房编码!");
        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverName()), "请输入收货库房!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getRecieverType()), "请输入收货点类型!");
//        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空!");
        model.setId(id);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseScStation dynamicBaseScStation = dynamicBaseScStationService.modify(model);
        return success(dynamicBaseScStation);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasescstation:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  dynamicBaseScStationService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseScStation> list = dynamicBaseScStationService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseScStation.class, "动态秤日报站点信息");
    }

    @ApiOperation(value = "启用", notes = "启用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/enable/{id}")
    public RESTfulResult enable(@PathVariable String id) {
        boolean flag = dynamicBaseScStationService.enable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }

    @ApiOperation(value = "禁用", notes = "禁用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/disable/{id}")
    public RESTfulResult disable(@PathVariable String id) {
        boolean flag = dynamicBaseScStationService.disable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }
}
